/* 
  KONNferencja - obsuga konferencji dla protokou Gadu-Gadu

  (c)2003 Rafa Lindemann / www.stamina.eu.org / www.konnekt.info

  Klasa group_base

  Kod udostpniany na licencji GPL, ktrej tre powinna by dostarczona
  razem z tym kodem.
  Licensed under GPL.

*/ 

#include "stdafx.h"
#include "konnekt/konnferencja.h"
#include "konnferencja.h"


void konnfer::createGroupObject(int cnt) {
	// Sprawdzamy czy kontakt jest "nasz"
	if (GETCNTI(cnt , CNT_NET)!= konnfer::net) return;
	std::string uid = GETCNTC(cnt , CNT_UID);
	int net;
	size_t pos = uid.find_last_of('@');
	if (pos == -1) {
		net = NET_GG;
	} else {
		net = atoi(uid.substr(pos+1).c_str());
		uid.erase(pos);
	}
	if (net == NET_GG) {
		uin_t uins [100];
		int count = 0;
		while (uid.size()) {
			// atoi sam wczyta numerek tylko do rednika...
			uins[count++] = atoi(uid.c_str());
			pos = uid.find(';');
			if (pos == -1) uid.clear();
			else uid.erase(0 , pos+1);
		}
		new group_gg(cnt , count , uins);
	}
}
void konnfer::destroyGroupObject(int cnt) {
	groups_it it = std::find(groups.begin() , groups.end() , cnt);
	if (it != groups.end()) {
		delete **it;
	}
}

int konnfer::getGroupUIDs(string uid , groupItems & items) {
	size_t pos;
	pos = uid.find_last_of('@');
	int net = NET_GG;
	if (pos!=-1) {
		net = atoi(uid.substr(pos+1).c_str());
		uid.erase(pos);
	}
	items.clear();
	while (uid.size()) {
		// atoi sam wczyta numerek tylko do rednika...
		pos = uid.find(';');
		items.push_back(uid.substr(0,pos));
		if (pos == -1) uid.clear();
		else uid.erase(0 , pos+1);
	}
	return net;
}



// group_base ----------------------------------------------------
group_base::group_base() {
	// wstawia si na list grup
	cnt = -1;
	groups.push_back(group_holder(this));
	IMLOG("group_base() size=%d" , groups.size());
}
group_base::~group_base() {
	// usuwa sam siebie z listy grup
	_ASSERTE(_CrtCheckMemory());
	groups_it it = std::find(groups.begin(), groups.end() , this);
	if (it!=groups.end()) groups.erase(it);
	_ASSERTE(_CrtCheckMemory());
}
void group_base::receiveMessage(cMessage * m , string from) {
	// w m juz siedza prawie wszystkie informacje, teraz trzeba je tylko
	// troche uzupelnic i wrzucic do kolejki...
	m->flag = MF_HANDLEDBYUI; // Wiadomo ma zosta w peni obsuona przez interfejs
	m->net = konnfer::net;    // Ustawiamy sie naszej wtyczki...
	string uid = this->getUID();
	m->fromUid = (char*)uid.c_str(); // Ustawiamy te odpowiedni UID
	m->toUid = "";
	m->type = MT_MESSAGE;     // Cao wysyana jest jako zwyka wiadomo
	m->notify = Ico::group_msg;
	// Jako e wiadomo obsugiwana jest przez interfejs, wysyana
	// jest jako cz zwykej rozmowy. UI w wersji 0.1.18 przyjmuje
	// w parametrach dodatkowych MEX_DISPLAY i uywa tego jako
	// autora wypowiedzi...
	string ext = SetExtParam(m->ext , MEX_DISPLAY , from);
	m->ext = (char*)ext.c_str();
	sMESSAGESELECT ms;
	ms.id = ICMessage(IMC_NEWMESSAGE , (int)m);
	if (ms.id && ms.id != -1)
		ICMessage(IMC_MESSAGEQUEUE , (int)&ms);
}
void group_base::createContact(string display , bool onList) {

	this->cnt = ICMessage(IMC_CNT_ADD , konnfer::net , (int)this->getUID().c_str());
	if (display.empty()) {
		// Trzeba wykombinowa jaki display...
		groupItems gi;
		int net = getGroupUIDs(this->getUID() , gi);
		for (groupItems_it it = gi.begin(); it != gi.end(); it++) {
			if (!display.empty()) display+=",";
			int cnt = ICMessage(IMC_FINDCONTACT , net , (int)it->c_str());
			if (cnt != -1)
				display += GETCNTC(cnt , CNT_DISPLAY);
			else display+=*it;
		}
	}
	SETCNTC(this->cnt , CNT_DISPLAY , display.c_str());
	SETCNTI(this->cnt , CNT_STATUS , ST_OFFLINE | (onList?0:ST_NOTINLIST));
	ICMessage(IMC_CNT_CHANGED , this->cnt);
}
void group_base::setActive(bool active) {
	sIMessage_StatusChange sc(IMC_CNT_SETSTATUS , this->cnt , active?ST_ONLINE:ST_OFFLINE , 0);
	Ctrl->IMessage(&sc);
	ICMessage(IMI_REFRESH_CNT , this->cnt);
}
