/* 
  KONNferencja - obsuga konferencji dla protokou Gadu-Gadu

  (c)2003 Rafa Lindemann / www.stamina.eu.org / www.konnekt.info

  Obsluga GaduGadu

  Kod udostpniany na licencji GPL, ktrej tre powinna by dostarczona
  razem z tym kodem.
  Licensed under GPL.

*/ 

#include "stdafx.h"
#include "konnekt/konnferencja.h"
#include "konnferencja.h"

// groupContents_gg --------------------------------------------------
void groupContents_gg::set(int count , const uin_t* uins) {
	if (this->uins) delete [] this->uins;
	this->uins = new uin_t[count];
	this->count = count;
	for (int i=0; i<count; i++)
		this->uins[i] = uins[i];
}
bool groupContents_gg::exists(uin_t uin) {
	if (!this->uins) return false;
	for (int i=0; i<this->count; i++)
		if (this->uins[i] == uin) return true;
	return false;
}

void groupContents_gg::add(int count , const uin_t* uins) {
	if (!this->uins) {set(count , uins); return;}
	uin_t * temp = new uin_t[this->count + count];
	// Kopiujemy to co byo
	for (int i=0; i<this->count; i++)
		temp[i] = this->uins[i];
	delete this->uins;
	this->uins = temp;
	// Dodajemy nowe, ale tylko jeli si nie powtarzaj
	for (int i=0; i<count; i++)
		if (!exists(uins[i])) 
			this->uins[this->count++] = uins[i];
}

groupContents_gg::~groupContents_gg() {
	if (this->uins) delete [] this->uins;
}
// Zwykle porownanie, tyle ze niezaleznie od kolejnosci wystepowania kontaktow
bool groupContents_gg::operator ==(const groupContents_gg & other) const {
	if (this->count != other.count) return false;
	for (int i=0; i<this->count; i++) {
		int j;
		for (j=0; j<this->count; j++) {
			// Jezeli znajdzie gdzies w srodku, sprawdza nastpny
			if (this->uins[i] == other.uins[j]) break;
		}
		// Skoro przelecia wszystkie i nie znalaz, znaczy e nie s te same
		if (j >= this->count) return false;
	}
	return true;
}


// group_gg

group_gg::group_gg(int count , const uin_t * uins , string display , bool onList) {
	items.set(count , uins);
	createContact(display , onList);
	if (IMessage(IM_ISCONNECTED , NET_GG , IMT_PROTOCOL))
		setActive(true);
}
group_gg::group_gg(int cnt, int count , const uin_t * uins) {
	items.set(count , uins);
	this->cnt = cnt;
}
bool group_gg::sendMessage(cMessage * m) {
	// Pobieramy obiekt sesji z GG
	gg_session * sess = (gg_session*) IMessage(IM_GG_GETSESSION , NET_GG , IMT_PROTOCOL);
	if (sess) {
		int result = gg_send_message_confer(sess , GG_CLASS_CHAT , items.getCount() , (uin_t*)items.getUins() , (const unsigned char*)m->body);
		// Zwalniamy obiekt sesji
		IMessage(IM_GG_RELEASESESSION , NET_GG , IMT_PROTOCOL);
		return result!=-1;
	} else return false;
}
bool group_gg::operator==(const groupContents_gg & test) const {
	return test == items;
}
string group_gg::getUID() {
	if (cnt>0) return GETCNTC(cnt , CNT_UID);
	// Skoro jeszcze go nie generowalimy, trzeba to zrobi po raz pierwszy...
	std::stringstream uid;
	for (int i=0; i<items.getCount(); i++) {
		if (i) uid << ";";
		uid << items.getUins()[i];
	}
	uid << "@10";
	return uid.str();
}


// ggEvents --------------------------------------------------
int konnfer::handleGGEvent(sIMessage_GGEvent * event) {
	switch (event->eventType) {
		case GGER_FIRSTLOOP: case GGER_LOGOUT: {
			// Ustawiamy statusy konferencji na wczone i wyczone...
			bool active = event->eventType == GGER_FIRSTLOOP;
			if (active) {
				// Skoro si poczylimy, wypadaoby przejrze kolejk, czy nie ma czego do wysania...
				ICMessage(IMC_MESSAGEQUEUE , (int)&sMESSAGESELECT(konnfer::net , 0 , MT_MESSAGE , MF_SEND));
			}
			for (groups_it it=groups.begin(); it!=groups.end(); it++)
				if ((*it)->getNet()==NET_GG)
					(*it)->setActive(active);
			break;}
		case GGER_EVENT: {
			gg_event * e = event->data.event;
			switch (e->type) {
				case GG_EVENT_MSG: {
					if (e->event.msg.msgclass == GG_CLASS_CTCP 
						|| !e->event.msg.message
						|| !*e->event.msg.message || e->event.msg.recipients_count==0) break;
					/* Sprawdzamy, czy mamy grup na licie...
					 Jeli nie, tworzymy j... Pomijamy w ten sposb
					 obsug wiadomoci spoza listy w interfejsie,
					 ktra w naszym przypadku, mogaby nie zadziaa
					 najlepiej */
					// Tworzymy kopi odbiorcw i dorzucamy wysyajcego do listy
					groupContents_gg gc(e->event.msg.recipients_count , e->event.msg.recipients);
					gc.add(1 , &e->event.msg.sender);
					groups_it it = std::find(groups.begin() , groups.end() , gc);
					group_gg * gr;
					if (it != groups.end())
						gr = static_cast<group_gg*>(**it);
					else {
						gr = new group_gg(gc.getCount() , gc.getUins() , "" , false);
					}
                    cMessage m;
                    m.body = (char*)e->event.msg.message;
					// Ustawiamy czas nadejcia wiadomoci...
					// Jeeli okno rozmowy jest zamknite, ustawiamy
					// na czas ustawiony w wiadomoci, chyba e
					// na komputerze jest wczeniejsza godzina...
					m.time = ICMessage(IMI_MSG_WINDOWSTATE , gr->getCnt())==0?
                        min(_time64(0) , e->event.msg.time)
                        :_time64(0)
                        ;
					char buff [32];
					itoa(e->event.msg.sender , buff , 10);
					string from = GETCNTC( ICMessage(IMC_FINDCONTACT , NET_GG , (int)buff) , CNT_DISPLAY);
					if (from.empty()) from = buff;
					gr->receiveMessage(&m , from);
					return GGERF_ABORT;}
			}
			break;}
	}
	return 0;
}
