#pragma once

extern gg_session * session;

namespace konnfer {

	/*
	Dla przyspieszenia procesu obsugi, jak i umoliwienia
	w przyszoci do atwego doczenia innych sieci
	grupy trzymane s we wtyczce jako lista obiektw. Niezalenie
	od ich reprezentacji w programie - czyli kontaktw na licie.
	*/


	// lista kontaktw GG
	class groupContents_gg {
	protected:
		int count;
		uin_t * uins;
	public:
		groupContents_gg(int count=0,const uin_t * uins=0) {
			this->count = count;
			this->uins = 0;
			if (count) set(count , uins);
		}
		void set(int count , const uin_t* uins);
		void add(int count , const uin_t* uins);
		bool exists(uin_t uin);
		~groupContents_gg();
		bool operator == (const groupContents_gg & other) const;
		int getCount() const {return count;}
		uin_t * getUins() const {return uins;}
	};


	// Klasa-Interfejs dla grup
	class group_base {
	protected:
		int cnt; // identyfikator kontaktu oznaczajacego grupe
		void createContact(std::string display , bool onList);
	public:
		group_base();
		virtual ~group_base();
		virtual bool sendMessage(cMessage * m)=0; // Wysyla wiadomosc do grupy
		virtual void receiveMessage(cMessage * m , std::string from); // Wywietla wiadomo od grupy uzupeniajc przy okazji pewne pola...
		virtual int getNet()=0; // Zwraca sie kontaktw w grupie
		virtual bool operator==(const class groupContents_gg & test) const {return false;} // sprawdza, czy grupa zawiera podane kontakty z GG
		virtual std::string getUID()=0;
		bool operator==(const int cnt) const {return this->cnt == cnt;}
		int getCnt() {return cnt;}
		void setActive(bool active);
		// Tworzy kontakt na licie kontaktw
	};

	class group_gg : public group_base {
	public:
		groupContents_gg items;
		// Konstruktor, tworzy kontakt
		group_gg(int count , const uin_t * uins , std::string display , bool onList);
		// Konstruktor, nie tworzy kontaktu
		group_gg(int cnt, int count , const uin_t * uins);
		bool sendMessage(cMessage * m); 
		int getNet() {return NET_GG;}
		bool operator==(const groupContents_gg & test) const ;
		std::string getUID();
	};
	// Klasa do trzymania obiektw w deque
	class group_holder {
	private:
		group_base * p;
	public:
		group_holder(group_base * p = 0) {this->p = p;}
		group_base * operator * () {return p;}
		group_base * operator -> () {return p;}
		bool operator==(const int cnt) const {return *p == cnt;}
		bool operator==(const group_base * p) const {return this->p == p;}
		bool operator==(const group_base & p) const {return this->p == &p;}
		bool operator==(const class groupContents_gg & test) const {return *p == test;}
	};

	// lista grup
	extern std::deque<group_holder> groups;
	typedef std::deque<group_holder>::iterator groups_it;
	// uzywane do rozbijania UIDa konferencji, na UIDy kontaktw
	typedef std::deque<string> groupItems;
	typedef std::deque<string>::iterator groupItems_it;


	// Tworzy / niszczy obiekty w groups dla kontaktw na licie
	void createGroupObject(int cnt);
	void destroyGroupObject(int cnt);
	int handleGGEvent(sIMessage_GGEvent * e);
	int getGroupUIDs(string uid , groupItems & items);

	// Operatory do porwnywania

}

using namespace konnfer;
